]>

# Guida a KMidi

Bernd Johannes
Wuebben

    wuebben@kde.org

Greg
Lee

    lee@hawaii.edu

Versione 1.1
17 Giugno 1998

Questa guida descrive KMidi Versione 1.1

MIDI
KDE
KMIDI
MID

## Introduzione

KMidi e' un lettore di file midi ed un convertitore da midi a wav.

Se hai ascoltato file midi su Linux/Unix allora provalo! Senza un eccessivo hardware come una Gravis Ultrasound oppure un Sound Blaster AWE64, ascolterai un suono fantastico, paragonabile a quello che avresti avuto con le schede menzionate qui sopra. Gratis!

In breve:

- KMidi usera' la CPU, di solito per il 10-30&percnt; a 32000 Hz sul mio Pentium 120. Se hai una macchina lenta, puoi utilizzare le opzioni da linea di comando per ridurre la frequenza di campionamento. Dovresti essere in grado di raggiungere un suono decente su un 486 senza sforzare la CPU.

- Occorrono pero' i patches sonori. Il set completo general midi e' reperibile in qualunque archivio Ultrasound. Dovrebbere occupare circa 10MB.

Credimi, per il risultato che otterrai, e' un piccolo prezzo da pagare!

KMidi supporta per ora (Versione 1.1) le seguenti piattaforme:

- Linux

- FreeBSD

- DEC OSF/1

- HP UX

- SUN

- SUN SOLARIS

Le versioni non-KDe di TiMidity, dovrebbero funzionare su tutte queste piattaforme, ma questa versione e' stata testata soltanto su Linux.

Il porting su altre piattaforme dovrebbe essere semplice. Contattami nel caso in cui tu abbia fatto il porting di kmidi per un'altra piattaforma.

KMidi si basa sul motore di TiMidity 0.2i di Tuukka Toivonen Copyright (C) 1995 Tukka Toivonen. In effetti nella distribuzione di KMidi e' inclusa una versione evoluta del programma originale con cinque diverse interfacce. (Guarda sotto per le informazioni sulla compilazione di TiMidity.) KMidi e TiMidity, con le estensioni AWE SoundFont fornite da Takashi Iwai e le estensioni AMD InterWave fornite da Greg Lee, ti permette di utilizzare i SoundFonts (.sbk/.sf2) e i patchset IW (.fff/.dat files) in aggiunta agli strumenti Gravis/Forte (.pat).

Per i dettagli non forniti in questo manuale, consulta la man page di timidity.

Non penso che questa sia una versione molto robusta, non e' molto difficile infatti che KMidi si blocchi. Comunque e' abbastanza stabile per darti tante ore di divetimento. Ricorda che i file midi occupano circa 50k o meno e si scaricano facilmente dalla rete. Divertiti con KMidi!

`Bernd Johannes Wuebben`, wuebben@kde.org

## Installazione

### Come ottenere KMidi

KMidi fa parte del progetto KDE http://www.kde.org. Puoi trovarlo su ftp://ftp.kde.org/pub/kde/, il sito ftp principale del progetto KDE. Il sito ufficiale e' http://math.cornell.edu/~wuebben/kde.html

### Requisiti

Per compilare con buon esito KMidi, hai bisogno dell'ultima versione di `libkdecore` e `libkdeui`. Tutte le librerie che ti servono come KMidi le trovi qui ftp://ftp.kde.org/pub/kde/.

Per compilare l'interfaccia "dumb" da linea di comando di TiMidity dovrebbero andar bene tutti i sistemi stile Unix e anche Win95.

Le altre interfacce hanno bisogno di requisiti speciali (vedi i vari README nella distribuzione). L'interfaccia Motif funziona piuttosto bene anche con Lesstif.

### Compilazione ed installazione

Se avevi gia' installato in precedenza KMidi, conviene fare un backup dei precedenti file di configurazione (di solito stanno in $KDEDIR/share/apps/kmidi/config/) prima di installare questa versione, perche' altrimenti verrebbero sovrascritti. Allo stesso modo, prima di installare la versione non-KDE di TiMidity, conserva in files che stanno in /usr/local/lib/timidity/. Se non vuoi mantenere i precedenti settaggi e' meglio eliminare tutti i file contenuti in queste directory, perche' i vecchi file potrebbero non essere rimpiazzati dalle nuove versioni.

Se hai l'intera distribuzione di kdemultimedia, vai nella directory di kdemultimedia e

    % ./configure

Quindi, per compilare tutti i programmi del pacchetto multimedia, rimani nella stessa directory oppure se ti serve solo KMidi vai nella directory kmidi

    % make
    % make install

Per le versioni non-KDE di TiMidity, edita il file Makefile.tim come richiesto, a seconda dell'interfaccia che vuoi compilare, poi

    % make clean
    % make -f Makefile.tim
    % make -f Makefile.tim install.bin
    % make -f Makefile.tim install.lib
    % make -f Makefile.tim install.man

Se dovessi avere dei problemi, contattami.

### Dove posso trovare un set completo di strumenti?

Ci sono tre tipi di strumenti che KMidi/TiMidity puo' usare: i patches GUS, IW `fonts`, e i SoundFonts AWE32. I set di campioni e i parametri per i singoli strumenti, un "patch", stanno in un file separato per i patches GUS, mentre gli IW fonts hanno tutti i campioni dei relativi set in un file `.dat` file e tutti i parametri raccolti in un file `.fff`. Gli AWE SoundFonts raccolgono tutto in un solo file `.sf2` (o `.sbk`). Questi sono dei siti dove puoi scaricare dei set di strumenti GUS:

Dan Hollis ha raccolto i patches GUS in un set. La sua pagina e': http://www.anime.net/~goemon/timidity e aiutalo affinche' lui possa fare il piu' bel set disponibile.

Novita': Ho messo su ftp.kde.org questo patchset. Per ora sta in `ftp://fiwi02.wiwi.uni-tuebingen.de/pub/kde/stable/Beta2/apps/multimedia/sound/` ma mi aspetto che verra' sistemato un po' in giro finche' non sara' trovata una posizione ideale. Quindi se non lo trovi facilmente prova al sito ufficiale.

I set di strumenti sono reperibili anche in pacchetti deb o rpm nell'archivio del Sunsite:

- Debian: timidity-patches_0.1.tar.gz

- RPM: timidity-patches-1-1.i386.rpm

- RPM: timidity-patches-1-1.src.rpm-try2

Non li ho ancora provati e personalmente utilizzo il patch set Midia con altri patches e drum set da me aggiunti.

Il patch set Midia puoi trovarlo qui: ftp://archive.cs.umbc.edu/pub/midia/

Per strumenti e drum sets aggiuntivi: (prendi gsdrum e wow patches) ftp://ftp.cdrom.com/pub/gus/sound/patches/files/

Vincent Pagel ha messo insieme una collezione di patches. Questo link funziona soltanto durante le ore notturne (orario di Parigi). ftp://sig.enst.fr/pub/midi/instruments/

Il file di configurazione per questi paches lo trovi qui: ftp://sig.enst.fr/pub/midi/timidity_pagel.cfg

Fai un giro anche sulla TimidityPage: http://www.clinet.fi/~toivonen/timidity/

e la Home Page di Takashi: http://bahamut.mm.t.u-tokyo.ac.jp/~iwai/midi.html#TiMidity

La Home Page di Takashi raccomanda il SoundFont AWE32 da 8 mega `chaos8m.sf2` e quello da 12 mega `chaos12m.sf2` disponibili su http://soback.kornet.nm.kr/~chaos/sbawe32/sbawe32.htm, che sono molto carini. (Sono degli archivi `.exe` autoscompattanti.)

Ci sono un sacco di IW fonts free su: ftp://sdc.wtm.tudelft.nl/pub/music/soundbank/. Che io sappia l'unico font IW con campioni stereo (che KMidi/TiMidity puo' suonare) costa 33$ su un cd; lo trovi su: http://sdc.wtm.tudelft.nl/utopia/.

#### Installazione degli strumenti

Ognuno dei set mensionati (te ne serve soltanto uno) dovrebbe comprendere un file .cfg di configurazione simile ai .cfg del KMidi e si trova in `KDEDIR/share/apps/kmidi/config`

KMidi ha gia' dei file di configurazione fatti per un buon numero di patch set, come il patch set Media.

Per completare l'installazione di un set di strumenti, edita il file timidity.cfg e includi gli appropriati file di configurazione per i patch set che hai scaricato.

E' tutto. Ora puoi divertirti a suonare tutti i midi della distribuzione (ed anche altri).

#### Varie

Occasionalmente vedrai che KMidi non puo' trovare un patch per un particolare strumento (Per vedere queste informazioni devi aprire la Info Window). In questo caso devi installare a mano il patch e modificare il file .cfg in modo da far capire a KMidi che c'e' un nuovo patch.

Qualche volta un particolare strumento non suona come dovrebbe. Procurati un patch differente per quello strumento dall'archivio Ultrasound e rimpiazza quello precedente.

## Utilizzo

### Utilizzo generale

Clicca sul pulsante "eject" per aprire il playlist manager. Scegli un file midi facendo un doppio click su di esso. Per convenienza ho incluso nella distribuzione qualche file midi. Per un utilizzo reale hai bisogno di un set completo general midi di strumenti.

### Nomi per i file midi

KMidi rimpiazzera ogni '&lowbar;' nel nome del file midi con uno spazio e togliera il .mid o .MID se presenti.

### Opzioni da linea di comando

    wuebben: ./kmidi -h
     KMidi version 0.3  MIDI to WAVE player/converter
     Copyright (C) 1995 Bernd Johannes Wuebben <wuebben@math.cornell.edu>

     KMidi is free software and comes with ABSOLUTELY NO WARRANTY.

    Usage:
      kmidi [options] filename [...]

    Options:
      -o file Output to another file (or device) (Use "-" for stdout)
      -O mode Select output mode and format (see below for list)
      -s f    Set sampling frequency to f (Hz or kHz)
      -a      Enable the antialiasing filter
      -f      Disable fast decay mode
      -p n    Allow n-voice polyphony
      -A n    Amplify volume by n percent (may cause clipping)
      -C n    Set ratio of sampling and control frequencies

      -L dir  Append dir to search path
      -c file Read extra configuration file
      -I n    Use program n as the default
      -P file Use patch file for all programs
      -D n    Play drums on channel n
      -Q n    Ignore channel n
      -F      Enable fast panning
      -U      Unload instruments from memory between MIDI files

      -i mode Select user interface (see below for list)
      -B n    Set number of buffer fragments
      -h      Display this help message

    Available output modes (-O option):

      -Od     Linux dsp device
      -Ow     RIFF WAVE file
      -Or     raw waveform data

    Output format options (append to -O? option):

       `8'    8-bit sample width
       `1'    16-bit sample width
       `U'    uLaw encoding
       `l'    linear encoding
       `M'    monophonic
       `S'    stereo
       `s'    signed output
       `u'    unsigned output
       `x'    byte-swapped output

    Available interfaces (-i option):

      -iq     kmidi qt  interface
      -id     dumb interface

    Interface options (append to -i? option):

       `v'    more verbose (cumulative)
       `q'    quieter (cumulative)
       `t'    trace playing

## Domande e risposte

### Dove posso reperire un set completo di strumenti?

Controlla nella corrispondente sezione nel capitolo riguardante l'installazione.

## Copyright

    KMidi Copyright 1997 Bernd Johannes Wuebben <wuebben@math.cornell.edu>

    KMidi utilizza il motore di timidity 0.2i di Tuukka Toivonen's,
    Copyright (C) 1995 Tukka Toivonen <toivonen@clinet.fi>

    Takashi Iwai <iwai@dragon.mm.t.u-tokyo.ac.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

La traduzione e' stata curata da:

Gianluigi Tiesi (tiesi@cli.di.unipi.it)